#include <Wire.h>
#include "Adafruit_TCS34725.h"


#include <iarduino_MultiServo.h>



#define pinX    A1  // ось X джойстика
#define pinY    A2  // ось Y джойстика
#define swPin    6  // кнопка джойстика
#define ledPin  13  // светодиод на Pin 13
#define lil_buttonPin 8 //МАЛЕНЬКАЯ КНОПКА
#define big_buttonPin 9 //БОЛЬШАЯ КНОПКА
#define commonAnode true

// our RGB -> eye-recognized gamma color
byte gammatable[256];


Adafruit_TCS34725 tcs = Adafruit_TCS34725(TCS34725_INTEGRATIONTIME_50MS, TCS34725_GAIN_4X);
iarduino_MultiServo MSS;
char Command;
float i = 40;  // переменные, отвечающие за перемещение
float j = 40;
float m = 5;
float n = 60;
float RGB;
float off;  //смещение. сколько будет прибавляться к переменным с каждым движением
bool flag = false;
bool k;
bool flaggg = false;
bool flagg=false;
int l;
int color;

int Position[150];

void setup() {

  MSS.begin();
  Serial.begin(19200);
    if (tcs.begin()) {
    Serial.println("Found sensor");
  } else {
    Serial.println("No TCS34725 found ... check your connections");
  while (1); // halt!
  }
  

  MSS.servoSet(0, SERVO_SG90);  // серва на  нулевом выходе платы расширения. Тип сервы SG90
  MSS.servoSet(1, SERVO_SG90);
   // серва на  первом выходе платы расширения. Тип сервы SG90
  MSS.servoSet(2, SERVO_SG90); // серва на  втором выходе платы расширения. Тип сервы SG90
  MSS.servoSet(3, SERVO_SG90); // серва на  третьем выходе платы расширения. Тип сервы SG90
  MSS.servoSet(4, SERVO_MG90);


  pinMode(ledPin, OUTPUT);
  pinMode(pinX, INPUT);
  pinMode(pinY, INPUT);
  pinMode(lil_buttonPin, INPUT);
  pinMode(big_buttonPin, INPUT);
  pinMode(swPin, INPUT);
  digitalWrite(swPin, HIGH);

}

void OPEN(){
    
      m=5;
      MSS.servoWrite(4, m); // установить вторую серву на 0. это положение "закыто"
      Serial.println("Flag true");

      delay(100);
}
void CLOSE(){
      m=80;
      MSS.servoWrite(4, m);
      Serial.println("Flag false");

      delay(100);
}
void UP(){
        i += off; // переменная уменьшается на off
      MSS.servoWrite(3, i); // сервику передается координата
      Serial.println("i+"); // в консоль выводится какая переменная была изменена.

}
void DOWN(){
        i -= off; // переменная увеличивается на off
      MSS.servoWrite(3, i); // сервику передается координата
      Serial.println("i-"); // в консоль выводится какая переменная была изменена.

}
void LEFT(){
        j -= off;
      MSS.servoWrite(1, j);
      Serial.println("j-");

      }
void RIGHT(){
        j += off;
      MSS.servoWrite(1, j);
      Serial.println("j+");

}
void UP2(){
        n += off;
      MSS.servoWrite(2, n);
      Serial.println("n+");

}
void DOWN2(){
        n -= off;
      MSS.servoWrite(2, n);
      Serial.println("n-");

}

void SAFE(){
     flaggg = true;
      l+=4;
      Position[l-4]=i;
      Position[l-3]=j;
      Position[l-2]=n;
      Position[l-1]=m;
      Serial.println("SAVE");
      delay(300);
}
void REPLAY(){
  for(int y=0; y<l; y++){

        if(y%4==0){
        MSS.servoWrite(3, Position[y]); 
        Serial.println("3");
        delay(250);
      }
      if(y%4==1){
        MSS.servoWrite(1 ,Position[y]);
         Serial.println("1");
        delay(250);
      }
      if(y%4==2){
        MSS.servoWrite(2 ,Position[y]);
        delay(250);
       Serial.println("2");
      }
      if(y%4==3){
        MSS.servoWrite(4 ,Position[y]);
         Serial.println("4");
        delay(250);
      }

}
void DELETE_ALL(){
  int Position[150];
}
void DELETE_LAST(){
  Position.pop();  
}
void Green(){
  Serial.println("GREEN DETECTET");
    MSS.servoWrite(3, 60);
    MSS.servoWrite(2, 30);
  delay(500);
 MSS.servoWrite(4, 80);
  delay(500);
  MSS.servoWrite(1, 0);
  delay(500);
  MSS.servoWrite(2, 35);
  MSS.servoWrite(3, 120);
  delay(500);
  MSS.servoWrite(4, 5);
  delay(500);
  MSS.servoWrite(3, 30);
  delay(500);
  MSS.servoWrite(1, 115);
  delay(500);
  MSS.servoWrite(2, 30);
  MSS.servoWrite(3, 30);
  delay(500);
  MSS.servoWrite(2, 20);
   MSS.servoWrite(3, 125);  
  delay(500);
   MSS.servoWrite(4, 80);
    delay(500);
    MSS.servoWrite(2, 60);
    MSS.servoWrite(3, 30);
  delay(500);
  MSS.servoWrite(1, 0);

  MSS.begin();
  

}

void Red(){
  Serial.println("RED DETECTET");
    MSS.servoWrite(3, 60);
    MSS.servoWrite(2, 30);
  delay(500);
 MSS.servoWrite(4, 80);
  delay(500);
  MSS.servoWrite(1, 0);
  delay(500);
  MSS.servoWrite(2, 35);
  MSS.servoWrite(3, 120);
  delay(500);
  MSS.servoWrite(4, 5);
  delay(500);
  MSS.servoWrite(3, 30);
  delay(500);
  MSS.servoWrite(1, 50);
  delay(500);
  MSS.servoWrite(2, 30);
  MSS.servoWrite(3, 30);
  delay(500);
  MSS.servoWrite(2, 20);
   MSS.servoWrite(3, 125);  
  delay(500);
   MSS.servoWrite(4, 80);
    delay(500);
    MSS.servoWrite(2, 60);
    MSS.servoWrite(3, 30);
  delay(500);
  MSS.servoWrite(1, 0);

  MSS.begin();
}

void Blue(){
  Serial.println("BLUE DETECTET");
    MSS.servoWrite(3, 60);
    MSS.servoWrite(2, 30);
  delay(500);
 MSS.servoWrite(4, 80);
  delay(500);
  MSS.servoWrite(1, 0);
  delay(500);
  MSS.servoWrite(2, 35);
  MSS.servoWrite(3, 120);
  delay(500);
  MSS.servoWrite(4, 5);
  delay(500);
  MSS.servoWrite(3, 30);
  delay(500);
  MSS.servoWrite(1, 80);
  delay(500);
  MSS.servoWrite(2, 30);
  MSS.servoWrite(3, 30);
  delay(500);
  MSS.servoWrite(2, 20);
   MSS.servoWrite(3, 125);  
  delay(500);
   MSS.servoWrite(4, 80);
    delay(500);
    MSS.servoWrite(2, 60);
    MSS.servoWrite(3, 30);
  delay(500);
  MSS.servoWrite(1, 0);

  MSS.begin();
}

void Yellow(){
    Serial.println("YELLOW DETECTET");
    MSS.servoWrite(3, 60);
    MSS.servoWrite(2, 30);
  delay(500);
 MSS.servoWrite(4, 80);
  delay(500);
  MSS.servoWrite(1, 0);
  delay(500);
  MSS.servoWrite(2, 35);
  MSS.servoWrite(3, 120);
  delay(500);
  MSS.servoWrite(4, 5);
  delay(500);
  MSS.servoWrite(3, 30);
  delay(500);
  MSS.servoWrite(1, 20);
  delay(500);
  MSS.servoWrite(2, 30);
  MSS.servoWrite(3, 30);
  delay(500);
  MSS.servoWrite(2, 20);
   MSS.servoWrite(3, 125);  
  delay(500);
   MSS.servoWrite(4, 80);
    delay(500);
    MSS.servoWrite(2, 60);
    MSS.servoWrite(3, 30);
  delay(500);
  MSS.servoWrite(1, 0);

  MSS.begin();
}

void loop() {   
  if(Serial.available()>0){
    Serial.print("SERIAL:");
    char data=Serial.read();
    Serial.println(data);
    if(data=='2'){
      Serial.println("UP");
      UP();

    }
        if(data=='1'){
      LEFT();
    }
         if(data=='0'){
      DOWN();
    }
      if(data=='3'){
      RIGHT();
    }
      if(data=='7' && flag == false){
        data=8;
        flag=true;
      OPEN();
    }
      if(data =='7' && flag == true){
        data=8;
        flag=false;
      CLOSE();
    }
    if(data=='10'){
      REPLAY();
    }
    if(data=='8'){
      SAFE();      
      
    }
        if(data=='9'){
          DELETE_LAST();
        }
        if(data=='12'){
          DELETE_ALL();
        }
        if(data=='11'){
          DELETE_LAST();
        }
  }


  
  uint16_t clear, red, green, blue;
  tcs.setInterrupt(false);      // turn on LED


  
  tcs.getRawData(&red, &green, &blue, &clear);

  tcs.setInterrupt(true);  // turn off LED
  off=analogRead(A3);
  off=map(off, 0,1023, 0, 20);
  Serial.print("off=");
  Serial.println(off);


  /*if (Serial.available() > 0) {
    Command = Serial.read();
    Serial.println(Command);}*/
  int X = analogRead(pinX);              // считываем значение оси Х
  int Y = analogRead(pinY);              // считываем значение оси Y
  bool lil_buttonState = digitalRead(lil_buttonPin); // считываем значение маленькой кнопки
  bool big_buttonState = digitalRead(big_buttonPin); // считываем значение большой кнопки

  green=map(green, 0,1000, 0,255);
red=map(red, 0,1000, 0,255);
blue=map(blue, 0,1000, 0,255);
    Serial.print("C:\t"); Serial.print(clear);
  Serial.print("\tR:\t"); Serial.print(red);
  Serial.print("\tG:\t"); Serial.print(green);
  Serial.print("\tB:\t"); Serial.println(blue);

  
  // Figure out some basic hex code for visualization
  uint32_t sum = clear;
  float r, g, b;
  r = red; r /= sum;
  g = green; g /= sum;
  b = blue; b /= sum;
  r *= 256; g *= 256; b *= 256;

  Serial.print((int)r, HEX); Serial.print((int)g, HEX); Serial.println((int)b, HEX);

     if(big_buttonState==HIGH){
    for(int y=0; y<l; y++){
      Serial.println(Position[y]);
      if(Position[y]=="UP();"){
        
        UP();
      }
      
    }
  }
  
  
//  if (big_buttonState == LOW) // если большая кнопка не нажата
//  {
    //Serial.println("manual mode");  // вывод в консоль "ручной режим"
    Serial.print("x = "); // вывод координат:
    Serial.println(X);
    Serial.print("y = ");
    Serial.println(Y);

    // ----------------- это механизм поочередного открывания и закрывания клешни
    int k = digitalRead(swPin); // считываем положение кнопки на джойстике
    Serial.println(k);
    if (k == 0 && flag == false) // если клешня закрыта
    {
       flag = true; // переменную, которая показывает открыта клешня или закрыта, установить как открыта
       k = 1; // перевести кнопку джойстика в состояние "ненажато" моментально нельзя поэтому здесь принудительно переменная переводится в это состояние, чтобы за одно физическое нажатие выполнялось одно действие
   OPEN();
   
    }

    if (k == 0 && flag == true) // аналогично для если клешня открыта
    {
      k = 1;
      flag = false;
      CLOSE();
    }
    // ----------------- это механизм движения остальных сервиков. для каждого сервика есть своя переменная, отвечающая за его координату. далее программа состоит из условий
    // которые проверяют состояние джойстика и в зависимости от его положения прибавляют (например, i += off) или убавляют (например, i -= off) значение переменной off

    if (X >= 1000 && Y >= 500 && Y <= 580) { // проверяется положение джойстика
    DOWN();
    }
    if (X <= 10 && Y <= 550) { // проверяется положение джойстика
    UP();
    }
    if (Y >= 1020 && X >= 490 && X <= 550) {

      RIGHT();
    }
    if (Y <= 10 && X >= 480 && X <= 550) {
      LEFT();

    }
    if (Y <= 1023 && Y >= 1020 && X <= 1023 && X >= 1020) {
    UP2();
    } 
    /*if (Y == 0 && X == 0) {
      m += off;
      MSS.servoWrite(0, m);
      Serial.println("m+");
      Serial.println(m);
    }*/

    if (Y >= 955 &&X >= 1020) {
      UP2();

    }
    if (X <= 0 && Y >= 1023) {
    DOWN2();
    }
    if(lil_buttonState ==HIGH && flaggg==false){
      SAFE();
    }
    if(lil_buttonState ==LOW && flaggg==true){
      flaggg = false;
    }
    if(big_buttonState ==HIGH && flaggg==false){
      flagg=true;
      Serial.println("ok");
            /*for(int y=0; y<l; y++){
        Serial.println(Position[y]);}*/
      REPLAY();
    }
   
}
if(green>red && green>blue && green>=200){
    Green();
  }
  else if(green && red >blue && green>=350 && red>=400){
  Yellow();
}
else if(red>green && red>blue && red>=200){
    Red();
  }  
else if(blue>green && blue>red && blue>=200){
    Blue();
  }

  /*else{
    NonColor();
  }*/
  if( big_buttonState ==LOW && flaggg==true){

      DELETE_ALL();

    
    flagg=false;
  }
  
}
